#include "services.h"

// search function
int services_known(int port, services_t *st)
{
	int i=0, j, m;
	if(!st) return(-1);
	j=st->nb-1;
	do {
		m=(i+j)/2;
		if(port==st->tab[m].port) return(m);
		if(port<st->tab[m].port) j=m-1;
		else i=m+1;
	} while (i<=j);
	return(-1);
}


// loading function (stupid, but stupid)
// services et comments shamefully taken from nmap
services_t *services_load()
{
	static services_t st;
	static services_elt services_tab[]={ \
	{"tcpmux", 1, "TCP Port Service Multiplexer [rfc-1078]"},\
	{"compressnet", 2, "Management Utility"},\
	{"compressnet", 3, "Compression Process"},\
	{"rje", 5, "Remote Job Entry"},\
	{"echo", 7, ""},\
	{"discard", 9, "sink null"},\
	{"systat", 11, "Active Users"},\
	{"daytime", 13, ""},\
	{"netstat", 15, ""},\
	{"qotd", 17, "Quote of the Day"},\
	{"msp", 18, "Message Send Protocol"},\
	{"chargen", 19, "ttytst source Character Generator"},\
	{"ftp-data", 20, "File Transfer [Default Data]"},\
	{"ftp", 21, "File Transfer [Control]"},\
	{"ssh", 22, "Secure Shell Login"},\
	{"telnet", 23, ""},\
	{"priv-mail", 24, "any private mail system"},\
	{"smtp", 25, "Simple Mail Transfer"},\
	{"nsw-fe", 27, "NSW User System FE"},\
	{"msg-icp", 29, "MSG ICP"},\
	{"msg-auth", 31, "MSG Authentication"},\
	{"dsp", 33, "Display Support Protocol"},\
	{"priv-print", 35, "any private printer server"},\
	{"time", 37, "timserver"},\
	{"rap", 38, "Route Access Protocol"},\
	{"rlp", 39, "Resource Location Protocol"},\
	{"graphics", 41, ""},\
	{"nameserver", 42, "Host Name Server"},\
	{"whois", 43, "nicname"},\
	{"mpm-flags", 44, "MPM FLAGS Protocol"},\
	{"mpm", 45, "Message Processing Module [recv]"},\
	{"mpm-snd", 46, "MPM [default send]"},\
	{"ni-ftp", 47, "NI FTP"},\
	{"auditd", 48, "Digital Audit Daemon"},\
	{"tacacs", 49, "Login Host Protocol (TACACS)"},\
	{"re-mail-ck", 50, "Remote Mail Checking Protocol"},\
	{"la-maint", 51, "IMP Logical Address Maintenance"},\
	{"xns-time", 52, "XNS Time Protocol"},\
	{"domain", 53, "Domain Name Server"},\
	{"xns-ch", 54, "XNS Clearinghouse"},\
	{"isi-gl", 55, "ISI Graphics Language"},\
	{"xns-auth", 56, "XNS Authentication"},\
	{"priv-term", 57, "any private terminal access"},\
	{"xns-mail", 58, "XNS Mail"},\
	{"priv-file", 59, "any private file service"},\
	{"ni-mail", 61, "NI MAIL"},\
	{"acas", 62, "ACA Services"},\
	{"via-ftp", 63, "VIA Systems - FTP & whois++"},\
	{"covia", 64, "Communications Integrator (CI)"},\
	{"tacacs-ds", 65, "TACACS-Database Service"},\
	{"sql*net", 66, "Oracle SQL*NET"},\
	{"bootps", 67, "Bootstrap Protocol Server"},\
	{"bootpc", 68, "Bootstrap Protocol Client"},\
	{"tftp", 69, "Trivial File Transfer"},\
	{"gopher", 70, ""},\
	{"netrjs-1", 71, "Remote Job Service"},\
	{"netrjs-2", 72, "Remote Job Service"},\
	{"netrjs-3", 73, "Remote Job Service"},\
	{"netrjs-4", 74, "Remote Job Service"},\
	{"priv-dial", 75, "any private dial out service"},\
	{"deos", 76, "Distributed External Object Store"},\
	{"priv-rje", 77, "any private RJE service, netrjs"},\
	{"vettcp", 78, ""},\
	{"finger", 79, ""},\
	{"http", 80, "World Wide Web HTTP"},\
	{"hosts2-ns", 81, "HOSTS2 Name Server"},\
	{"xfer", 82, "XFER Utility"},\
	{"mit-ml-dev", 83, "MIT ML Device"},\
	{"ctf", 84, "Common Trace Facility"},\
	{"mit-ml-dev", 85, "MIT ML Device"},\
	{"mfcobol", 86, "Micro Focus Cobol"},\
	{"priv-term-l", 87, "any private terminal link, ttylink"},\
	{"kerberos-sec", 88, "Kerberos (v5)"},\
	{"su-mit-tg", 89, "SU/MIT Telnet Gateway"},\
	{"dnsix", 90, "DNSIX Securit Attribute Token Map"},\
	{"mit-dov", 91, "MIT Dover Spooler"},\
	{"npp", 92, "Network Printing Protocol"},\
	{"dcp", 93, "Device Control Protocol"},\
	{"objcall", 94, "Tivoli Object Dispatcher"},\
	{"supdup", 95, "BSD supdupd(8)"},\
	{"dixie", 96, "DIXIE Protocol Specification"},\
	{"swift-rvf", 97, "Swift Remote Virtural File Protocol"},\
	{"linuxconf", 98, "linuxconf"},\
	{"metagram", 99, "Metagram Relay"},\
	{"newacct", 100, "[unauthorized use]"},\
	{"hostname", 101, "hostnames NIS Host Name Server"},\
	{"iso-tsap", 102, "tsap ISO-TSAP Class 0"},\
	{"gppitnp", 103, "Genesis Point-to-Point Trans Net, or x400 ISO Email"},\
	{"acr-nema", 104, "ACR-NEMA Digital Imag. & Comm. 300"},\
	{"csnet-ns", 105, "Mailbox Name Nameserver"},\
	{"pop3pw", 106, "Eudora compatible PW changer"},\
	{"rtelnet", 107, "Remote Telnet"},\
	{"snagas", 108, "SNA Gateway Access Server"},\
	{"pop-2", 109, "PostOffice V.2"},\
	{"pop-3", 110, "PostOffice V.3"},\
	{"sunrpc", 111, "portmapper, rpcbind"},\
	{"mcidas", 112, "McIDAS Data Transmission Protocol"},\
	{"auth", 113, "ident, tap, Authentication Service"},\
	{"audionews", 114, "Audio News Multicast"},\
	{"sftp", 115, "Simple File Transfer Protocol"},\
	{"ansanotify", 116, "ANSA REX Notify"},\
	{"uucp-path", 117, "UUCP Path Service"},\
	{"sqlserv", 118, "SQL Services"},\
	{"nntp", 119, "Network News Transfer Protocol"},\
	{"cfdptkt", 120, ""},\
	{"erpc", 121, "Encore Expedited Remote Pro.Call"},\
	{"smakynet", 122, ""},\
	{"ntp", 123, "Network Time Protocol"},\
	{"ansatrader", 124, "ANSA REX Trader"},\
	{"locus-map", 125, "Locus PC-Interface Net Map Ser"},\
	{"unitary", 126, "Unisys Unitary Login"},\
	{"locus-con", 127, "Locus PC-Interface Conn Server"},\
	{"gss-xlicen", 128, "GSS X License Verification"},\
	{"pwdgen", 129, "Password Generator Protocol"},\
	{"cisco-fna", 130, "cisco FNATIVE"},\
	{"cisco-tna", 131, "cisco TNATIVE"},\
	{"cisco-sys", 132, "cisco SYSMAINT"},\
	{"statsrv", 133, "Statistics Service"},\
	{"ingres-net", 134, "INGRES-NET Service"},\
	{"loc-srv", 135, "NCS local location broker"},\
	{"profile", 136, "PROFILE Naming System"},\
	{"netbios-ns", 137, "NETBIOS Name Service"},\
	{"netbios-dgm", 138, "NETBIOS Datagram Service"},\
	{"netbios-ssn", 139, "NETBIOS Session Service"},\
	{"emfis-data", 140, "EMFIS Data Service"},\
	{"emfis-cntl", 141, "EMFIS Control Service"},\
	{"bl-idm", 142, "Britton-Lee IDM"},\
	{"imap2", 143, "Interim Mail Access Protocol v2"},\
	{"news", 144, "NewS window system"},\
	{"uaac", 145, "UAAC Protocol"},\
	{"iso-tp0", 146, ""},\
	{"iso-ip", 147, ""},\
	{"cronus", 148, "CRONUS-SUPPORT"},\
	{"aed-512", 149, "AED 512 Emulation Service"},\
	{"sql-net", 150, ""},\
	{"hems", 151, ""},\
	{"bftp", 152, "Background File Transfer Program"},\
	{"sgmp", 153, ""},\
	{"netsc-prod", 154, ""},\
	{"netsc-dev", 155, ""},\
	{"sqlsrv", 156, "SQL Service"},\
	{"knet-cmp", 157, "KNET/VM Command/Message Protocol"},\
	{"pcmail-srv", 158, "PCMail Server"},\
	{"nss-routing", 159, ""},\
	{"sgmp-traps", 160, ""},\
	{"snmp", 161, ""},\
	{"snmptrap", 162, "snmp-trap"},\
	{"cmip-man", 163, "CMIP/TCP Manager"},\
	{"cmip-agent", 164, "CMIP/TCP Agent"},\
	{"xns-courier", 165, "Xerox"},\
	{"s-net", 166, "Sirius Systems"},\
	{"namp", 167, ""},\
	{"rsvd", 168, ""},\
	{"send", 169, ""},\
	{"print-srv", 170, "Network PostScript"},\
	{"multiplex", 171, "Network Innovations Multiplex"},\
	{"cl-1", 172, "Network Innovations CL/1"},\
	{"xyplex-mux", 173, ""},\
	{"mailq", 174, ""},\
	{"vmnet", 175, ""},\
	{"genrad-mux", 176, ""},\
	{"xdmcp", 177, "X Display Mgr. Control Proto"},\
	{"nextstep", 178, "NextStep Window Server"},\
	{"bgp", 179, "Border Gateway Protocol"},\
	{"ris", 180, "Intergraph"},\
	{"unify", 181, ""},\
	{"audit", 182, "Unisys Audit SITP"},\
	{"ocbinder", 183, ""},\
	{"ocserver", 184, ""},\
	{"remote-kis", 185, ""},\
	{"kis", 186, "KIS Protocol"},\
	{"aci", 187, "Application Communication Interface"},\
	{"mumps", 188, "Plus Five's MUMPS"},\
	{"qft", 189, "Queued File Transport"},\
	{"gacp", 190, "Gateway Access Control Protocol"},\
	{"prospero", 191, "Prospero Directory Service"},\
	{"osu-nms", 192, "OSU Network Monitoring System"},\
	{"srmp", 193, "Spider Remote Monitoring Protocol"},\
	{"irc", 194, "Internet Relay Chat"},\
	{"dn6-nlm-aud", 195, "DNSIX Network Level Module Audit"},\
	{"dn6-smm-red", 196, "DNSIX Session Mgt Module Audit Redir"},\
	{"dls", 197, "Directory Location Service"},\
	{"dls-mon", 198, "Directory Location Service Monitor"},\
	{"smux", 199, "SNMP Unix Multiplexer"},\
	{"src", 200, "IBM System Resource Controller"},\
	{"at-rtmp", 201, "AppleTalk Routing Maintenance"},\
	{"at-nbp", 202, "AppleTalk Name Binding"},\
	{"at-3", 203, "AppleTalk Unused"},\
	{"at-echo", 204, "AppleTalk Echo"},\
	{"at-5", 205, "AppleTalk Unused"},\
	{"at-zis", 206, "AppleTalk Zone Information"},\
	{"at-7", 207, "AppleTalk Unused"},\
	{"at-8", 208, "AppleTalk Unused"},\
	{"tam", 209, "Trivial Authenticated Mail Protocol"},\
	{"z39.50", 210, "wais, ANSI Z39.50"},\
	{"914c-g", 211, "Texas Instruments 914C/G Terminal"},\
	{"anet", 212, "ATEXSSTR"},\
	{"ipx", 213, ""},\
	{"vmpwscs", 214, ""},\
	{"softpc", 215, "Insignia Solutions"},\
	{"atls", 216, "Access Technology License Server"},\
	{"dbase", 217, "dBASE Unix"},\
	{"mpp", 218, "Netix Message Posting Protocol"},\
	{"uarps", 219, "Unisys ARPs"},\
	{"imap3", 220, "Interactive Mail Access Protocol v3"},\
	{"fln-spx", 221, "Berkeley rlogind with SPX auth"},\
	{"rsh-spx", 222, "Berkeley rshd with SPX auth"},\
	{"cdc", 223, "Certificate Distribution Center"},\
	{"direct", 242, ""},\
	{"sur-meas", 243, "Survey Measurement"},\
	{"dayna", 244, ""},\
	{"link", 245, ""},\
	{"dsp3270", 246, "Display Systems Protocol"},\
	{"subntbcst_tftp", 247, ""},\
	{"bhfhs", 248, ""},\
	{"rap", 256, ""},\
	{"set", 257, "secure electronic transaction"},\
	{"yak-chat", 258, "yak winsock personal chat"},\
	{"esro-gen", 259, "efficient short remote operations"},\
	{"openport", 260, ""},\
	{"nsiiops", 261, "iiop name service over tls/ssl"},\
	{"arcisdms", 262, ""},\
	{"hdap", 263, ""},\
	{"bgmp", 264, ""},\
	{"http-mgmt", 280, ""},\
	{"personal-link", 281, ""},\
	{"cableport-ax", 282, "cable port a/x"},\
	{"novastorbakcup", 308, "novastor backup"},\
	{"entrusttime", 309, ""},\
	{"bhmds", 310, ""},\
	{"asip-webadmin", 311, "appleshare ip webadmin"},\
	{"vslmp", 312, ""},\
	{"magenta-logic", 313, ""},\
	{"opalis-robot", 314, ""},\
	{"dpsi", 315, ""},\
	{"decauth", 316, ""},\
	{"zannet", 317, ""},\
	{"pip", 321, ""},\
	{"pdap", 344, "Prospero Data Access Protocol"},\
	{"pawserv", 345, "Perf Analysis Workbench"},\
	{"zserv", 346, "Zebra server"},\
	{"fatserv", 347, "Fatmen Server"},\
	{"csi-sgwp", 348, "Cabletron Management Protocol"},\
	{"mftp", 349, ""},\
	{"matip-type-a", 350, "MATIP Type A"},\
	{"matip-type-b", 351, "MATIP Type B or bhoetty"},\
	{"dtag-ste-sb", 352, "DTAG, or bhoedap4"},\
	{"ndsauth", 353, ""},\
	{"bh611", 354, ""},\
	{"datex-asn", 355, ""},\
	{"cloanto-net-1", 356, "Cloanto Net 1"},\
	{"bhevent", 357, ""},\
	{"shrinkwrap", 358, ""},\
	{"tenebris_nts", 359, "Tenebris Network Trace Service"},\
	{"scoi2odialog", 360, ""},\
	{"semantix", 361, ""},\
	{"srssend", 362, "SRS Send"},\
	{"rsvp_tunnel", 363, ""},\
	{"aurora-cmgr", 364, ""},\
	{"dtk", 365, "Deception Tool Kit (lame -- see www.all.net) "},\
	{"odmr", 366, ""},\
	{"mortgageware", 367, ""},\
	{"qbikgdp", 368, ""},\
	{"rpc2portmap", 369, ""},\
	{"codaauth2", 370, ""},\
	{"clearcase", 371, ""},\
	{"ulistserv", 372, "Unix Listserv"},\
	{"legent-1", 373, "Legent Corporation (now Computer Associates Intl.)"},\
	{"legent-2", 374, "Legent Corporation (now Computer Associates Intl.)"},\
	{"hassle", 375, ""},\
	{"nip", 376, "Amiga Envoy Network Inquiry Proto"},\
	{"tnETOS", 377, "NEC Corporation"},\
	{"dsETOS", 378, "NEC Corporation"},\
	{"is99c", 379, "TIA/EIA/IS-99 modem client"},\
	{"is99s", 380, "TIA/EIA/IS-99 modem server"},\
	{"hp-collector", 381, "hp performance data collector"},\
	{"hp-managed-node", 382, "hp performance data managed node"},\
	{"hp-alarm-mgr", 383, "hp performance data alarm manager"},\
	{"arns", 384, "A Remote Network Server System"},\
	{"ibm-app", 385, "IBM Application"},\
	{"asa", 386, "ASA Message Router Object Def."},\
	{"aurp", 387, "Appletalk Update-Based Routing Pro."},\
	{"unidata-ldm", 388, "Unidata LDM Version 4"},\
	{"ldap", 389, "Lightweight Directory Access Protocol"},\
	{"uis", 390, ""},\
	{"synotics-relay", 391, "SynOptics SNMP Relay Port"},\
	{"synotics-broker", 392, "SynOptics Port Broker Port"},\
	{"dis", 393, "Data Interpretation System"},\
	{"embl-ndt", 394, "EMBL Nucleic Data Transfer"},\
	{"netcp", 395, "NETscout Control Protocol"},\
	{"netware-ip", 396, "Novell Netware over IP"},\
	{"mptn", 397, "Multi Protocol Trans. Net."},\
	{"kryptolan", 398, ""},\
	{"iso-tsap-c2", 399, "ISO-TSAP Class 2"},\
	{"work-sol", 400, "Workstation Solutions"},\
	{"ups", 401, "Uninterruptible Power Supply"},\
	{"genie", 402, "Genie Protocol"},\
	{"decap", 403, ""},\
	{"nced", 404, ""},\
	{"ncld", 405, ""},\
	{"imsp", 406, "Interactive Mail Support Protocol"},\
	{"timbuktu", 407, ""},\
	{"prm-sm", 408, "Prospero Resource Manager Sys. Man."},\
	{"prm-nm", 409, "Prospero Resource Manager Node Man."},\
	{"decladebug", 410, "DECLadebug Remote Debug Protocol"},\
	{"rmt", 411, "Remote MT Protocol"},\
	{"synoptics-trap", 412, "Trap Convention Port"},\
	{"smsp", 413, ""},\
	{"infoseek", 414, ""},\
	{"bnet", 415, ""},\
	{"silverplatter", 416, ""},\
	{"onmux", 417, ""},\
	{"hyper-g", 418, ""},\
	{"ariel1", 419, ""},\
	{"smpte", 420, ""},\
	{"ariel2", 421, ""},\
	{"ariel3", 422, ""},\
	{"opc-job-start", 423, "IBM Operations Planning and Control Start"},\
	{"opc-job-track", 424, "IBM Operations Planning and Control Track"},\
	{"icad-el", 425, ""},\
	{"smartsdp", 426, ""},\
	{"svrloc", 427, "Server Location"},\
	{"ocs_cmu", 428, ""},\
	{"ocs_amu", 429, ""},\
	{"utmpsd", 430, ""},\
	{"utmpcd", 431, ""},\
	{"iasd", 432, ""},\
	{"nnsp", 433, "Usenet, Network News Transfer"},\
	{"mobileip-agent", 434, ""},\
	{"mobilip-mn", 435, ""},\
	{"dna-cml", 436, ""},\
	{"comscm", 437, ""},\
	{"dsfgw", 438, ""},\
	{"dasp", 439, ""},\
	{"sgcp", 440, ""},\
	{"decvms-sysmgt", 441, ""},\
	{"cvc_hostd", 442, ""},\
	{"https", 443, "secure http (SSL)"},\
	{"snpp", 444, "Simple Network Paging Protocol"},\
	{"microsoft-ds", 445, ""},\
	{"ddm-rdb", 446, ""},\
	{"ddm-dfm", 447, ""},\
	{"ddm-ssl", 448, "ddm-byte"},\
	{"as-servermap", 449, "AS Server Mapper"},\
	{"tserver", 450, ""},\
	{"sfs-smp-net", 451, "Cray Network Semaphore server"},\
	{"sfs-config", 452, "Cray SFS config server"},\
	{"creativeserver", 453, ""},\
	{"contentserver", 454, ""},\
	{"creativepartnr", 455, ""},\
	{"macon-tcp", 456, ""},\
	{"scohelp", 457, ""},\
	{"appleqtc", 458, "apple quick time"},\
	{"ampr-rcmd", 459, ""},\
	{"skronk", 460, ""},\
	{"datasurfsrv", 461, ""},\
	{"datasurfsrvsec", 462, ""},\
	{"alpes", 463, ""},\
	{"kpasswd5", 464, "Kerberos (v5)"},\
	{"smtps", 465, "smtp protocol over TLS/SSL (was ssmtp)"},\
	{"digital-vrc", 466, ""},\
	{"mylex-mapd", 467, ""},\
	{"photuris", 468, "Photuris Key Management"},\
	{"rcp", 469, "Radio Control Protocol"},\
	{"scx-proxy", 470, ""},\
	{"mondex", 471, ""},\
	{"ljk-login", 472, ""},\
	{"hybrid-pop", 473, ""},\
	{"tn-tl-w1", 474, ""},\
	{"tcpnethaspsrv", 475, ""},\
	{"tn-tl-fd1", 476, ""},\
	{"ss7ns", 477, ""},\
	{"spsc", 478, ""},\
	{"iafserver", 479, ""},\
	{"loadsrv", 480, ""},\
	{"dvs", 481, ""},\
	{"bgs-nsi", 482, ""},\
	{"ulpnet", 483, ""},\
	{"integra-sme", 484, "Integra Software Management Environment"},\
	{"powerburst", 485, "Air Soft Power Burst"},\
	{"sstats", 486, ""},\
	{"saft", 487, "saft Simple Asynchronous File Transfer"},\
	{"gss-http", 488, ""},\
	{"nest-protocol", 489, ""},\
	{"micom-pfs", 490, ""},\
	{"go-login", 491, ""},\
	{"ticf-1", 492, "Transport Independent Convergence for FNA"},\
	{"ticf-2", 493, "Transport Independent Convergence for FNA"},\
	{"pov-ray", 494, ""},\
	{"intecourier", 495, ""},\
	{"pim-rp-disc", 496, ""},\
	{"dantz", 497, ""},\
	{"siam", 498, ""},\
	{"iso-ill", 499, "ISO ILL Protocol"},\
	{"isakmp", 500, ""},\
	{"stmf", 501, ""},\
	{"asa-appl-proto", 502, ""},\
	{"intrinsa", 503, ""},\
	{"citadel", 504, ""},\
	{"mailbox-lm", 505, ""},\
	{"ohimsrv", 506, ""},\
	{"crs", 507, ""},\
	{"xvttp", 508, ""},\
	{"snare", 509, ""},\
	{"fcp", 510, "FirstClass Protocol"},\
	{"passgo", 511, ""},\
	{"exec", 512, "BSD rexecd(8)"},\
	{"login", 513, "BSD rlogind(8)"},\
	{"shell", 514, "BSD rshd(8)"},\
	{"printer", 515, "spooler (lpd)"},\
	{"videotex", 516, ""},\
	{"talk", 517, "like tenex link, but across"},\
	{"ntalk", 518, "(talkd)"},\
	{"utime", 519, "unixtime"},\
	{"efs", 520, "extended file name server"},\
	{"ripng", 521, ""},\
	{"ulp", 522, ""},\
	{"ibm-db2", 523, ""},\
	{"ncp", 524, ""},\
	{"timed", 525, "timeserver"},\
	{"tempo", 526, "newdate"},\
	{"stx", 527, "Stock IXChange"},\
	{"custix", 528, "Customer IXChange"},\
	{"irc-serv", 529, ""},\
	{"courier", 530, "rpc"},\
	{"conference", 531, "chat"},\
	{"netnews", 532, "readnews"},\
	{"netwall", 533, "for emergency broadcasts"},\
	{"mm-admin", 534, "MegaMedia Admin"},\
	{"iiop", 535, ""},\
	{"opalis-rdv", 536, ""},\
	{"nmsp", 537, "Networked Media Streaming Protocol"},\
	{"gdomap", 538, ""},\
	{"apertus-ldp", 539, "Apertus Technologies Load Determination"},\
	{"uucp", 540, "uucpd"},\
	{"uucp-rlogin", 541, ""},\
	{"commerce", 542, ""},\
	{"klogin", 543, "Kerberos (v4/v5)"},\
	{"kshell", 544, "krcmd Kerberos (v4/v5)"},\
	{"ekshell", 545, "Kerberos encrypted remote shell -kfall"},\
	{"dhcpv6-client", 546, "DHCPv6 Client"},\
	{"dhcpv6-server", 547, "DHCPv6 Server"},\
	{"afpovertcp", 548, "AFP over TCP"},\
	{"idfp", 549, ""},\
	{"new-rwho", 550, "new-who"},\
	{"cybercash", 551, ""},\
	{"deviceshare", 552, ""},\
	{"pirp", 553, ""},\
	{"rtsp", 554, "Real Time Stream Control Protocol"},\
	{"dsf", 555, ""},\
	{"remotefs", 556, "rfs, rfs_server, Brunhoff remote filesystem"},\
	{"openvms-sysipc", 557, ""},\
	{"sdnskmp", 558, ""},\
	{"teedtap", 559, ""},\
	{"rmonitor", 560, "rmonitord"},\
	{"monitor", 561, ""},\
	{"chshell", 562, "chcmd"},\
	{"snews", 563, ""},\
	{"9pfs", 564, "plan 9 file service"},\
	{"whoami", 565, ""},\
	{"streettalk", 566, ""},\
	{"banyan-rpc", 567, ""},\
	{"ms-shuttle", 568, "Microsoft shuttle"},\
	{"ms-rome", 569, "Microsoft rome"},\
	{"meter", 570, "demon"},\
	{"umeter", 571, "udemon"},\
	{"sonar", 572, ""},\
	{"banyan-vip", 573, ""},\
	{"ftp-agent", 574, "FTP Software Agent System"},\
	{"vemmi", 575, ""},\
	{"ipcd", 576, ""},\
	{"vnas", 577, ""},\
	{"ipdd", 578, ""},\
	{"decbsrv", 579, ""},\
	{"sntp-heartbeat", 580, ""},\
	{"bdp", 581, "Bundle Discovery Protocol"},\
	{"scc-security", 582, ""},\
	{"philips-vc", 583, "Philips Video-Conferencing"},\
	{"keyserver", 584, ""},\
	{"imap4-ssl", 585, "IMAP4+SSL (use of 585 is not recommended,"},\
	{"password-chg", 586, ""},\
	{"submission", 587, ""},\
	{"cal", 588, ""},\
	{"eyelink", 589, ""},\
	{"tns-cml", 590, ""},\
	{"http-alt", 591, "FileMaker, Inc. - HTTP Alternate"},\
	{"eudora-set", 592, ""},\
	{"http-rpc-epmap", 593, "HTTP RPC Ep Map"},\
	{"tpip", 594, ""},\
	{"cab-protocol", 595, ""},\
	{"smsd", 596, ""},\
	{"ptcnameservice", 597, "PTC Name Service"},\
	{"sco-websrvrmg3", 598, "SCO Web Server Manager 3"},\
	{"acp", 599, "Aeolon Core Protocol"},\
	{"ipcserver", 600, "Sun IPC server"},\
	{"urm", 606, "Cray Unified Resource Manager"},\
	{"nqs", 607, ""},\
	{"sift-uft", 608, "Sender-Initiated/Unsolicited File Transfer"},\
	{"npmp-trap", 609, ""},\
	{"npmp-local", 610, ""},\
	{"npmp-gui", 611, ""},\
	{"qmqp", 628, "Qmail Quick Mail Queueing"},\
	{"ginad", 634, ""},\
	{"ldapssl", 636, "LDAP over SSL"},\
	{"doom", 666, "doom Id Software"},\
	{"elcsd", 704, "errlog copy/server daemon"},\
	{"entrustmanager", 709, "EntrustManager - NorTel DES auth network see 389/tcp"},\
	{"netviewdm1", 729, "IBM NetView DM/6000 Server/Client"},\
	{"netviewdm2", 730, "IBM NetView DM/6000 send/tcp"},\
	{"netviewdm3", 731, "IBM NetView DM/6000 receive/tcp"},\
	{"netcp", 740, "NETscout Control Protocol"},\
	{"netgw", 741, ""},\
	{"netrcs", 742, "Network based Rev. Cont. Sys."},\
	{"flexlm", 744, "Flexible License Manager"},\
	{"fujitsu-dev", 747, "Fujitsu Device Control"},\
	{"ris-cm", 748, "Russell Info Sci Calendar Manager"},\
	{"kerberos-adm", 749, "Kerberos 5 admin/changepw"},\
	{"kerberos", 750, "kdc Kerberos (v4)"},\
	{"kerberos_master", 751, "Kerberos `kadmin' (v4)"},\
	{"qrh", 752, ""},\
	{"rrh", 753, ""},\
	{"krb_prop", 754, "kerberos/v5 server propagation"},\
	{"nlogin", 758, ""},\
	{"con", 759, ""},\
	{"krbupdate", 760, "kreg Kerberos (v4) registration"},\
	{"kpasswd", 761, "kpwd Kerberos (v4) 'passwd'"},\
	{"quotad", 762, ""},\
	{"cycleserv", 763, ""},\
	{"omserv", 764, ""},\
	{"webster", 765, ""},\
	{"phonebook", 767, "phone"},\
	{"vid", 769, ""},\
	{"cadlock", 770, ""},\
	{"rtip", 771, ""},\
	{"cycleserv2", 772, ""},\
	{"submit", 773, ""},\
	{"rpasswd", 774, ""},\
	{"entomb", 775, ""},\
	{"wpages", 776, ""},\
	{"wpgs", 780, ""},\
	{"hp-collector", 781, "hp performance data collector"},\
	{"hp-managed-node", 782, "hp performance data managed node"},\
	{"hp-alarm-mgr", 783, "hp performance data alarm manager"},\
	{"concert", 786, ""},\
	{"controlit", 799, ""},\
	{"mdbs_daemon", 800, ""},\
	{"device", 801, ""},\
	{"supfilesrv", 871, "SUP server"},\
	{"accessbuilder", 888, "or Audio CD Database"},\
	{"ftps-data", 989, "ftp protocol, data, over TLS/SSL"},\
	{"samba-swat", 901, "Samba SWAT tool"},\
	{"ftps", 990, "ftp protocol, control, over TLS/SSL"},\
	{"telnets", 992, "telnet protocol over TLS/SSL"},\
	{"imaps", 993, "imap4 protocol over TLS/SSL"},\
	{"ircs", 994, "irc protocol over TLS/SSL"},\
	{"pop3s", 995, "POP3 protocol over TLS/SSL"},\
	{"xtreelic", 996, "XTREE License Server"},\
	{"maitrd", 997, ""},\
	{"busboy", 998, ""},\
	{"garcon", 999, ""},\
	{"cadlock", 1000, ""},\
	{"ufsd", 1008, "UFS-aware server"},\
	{"kdm", 1024, "K Display Manager (KDE version of xdm)"},\
	{"listen", 1025, "listener RFS remote_file_sharing"},\
	{"nterm", 1026, "remote_login network_terminal"},\
	{"iad1", 1030, "BBN IAD"},\
	{"iad2", 1031, "BBN IAD"},\
	{"iad3", 1032, "BBN IAD"},\
	{"nim", 1058, ""},\
	{"nimreg", 1059, ""},\
	{"instl_boots", 1067, "Installation Bootstrap Proto. Serv."},\
	{"instl_bootc", 1068, "Installation Bootstrap Proto. Cli."},\
	{"socks", 1080, ""},\
	{"ansoft-lm-1", 1083, "Anasoft License Manager"},\
	{"ansoft-lm-2", 1084, "Anasoft License Manager"},\
	{"xaudio", 1103, "Xaserver	# X Audio Server"},\
	{"kpop", 1109, "Pop with Kerberos"},\
	{"nfsd-status", 1110, "Cluster status info"},\
	{"msql", 1112, "mini-sql server"},\
	{"supfiledbg", 1127, "SUP debugging"},\
	{"nfa", 1155, "Network File Access"},\
	{"skkserv", 1178, "SKK (kanji input)"},\
	{"lupa", 1212, ""},\
	{"nerv", 1222, "SNI R&D network"},\
	{"hotline", 1234, ""},\
	{"msg", 1241, "remote message server"},\
	{"hermes", 1248, ""},\
	{"alta-ana-lm", 1346, "Alta Analytics License Manager"},\
	{"bbn-mmc", 1347, "multi media conferencing"},\
	{"bbn-mmx", 1348, "multi media conferencing"},\
	{"sbook", 1349, "Registration Network Protocol"},\
	{"editbench", 1350, "Registration Network Protocol"},\
	{"equationbuilder", 1351, "Digital Tool Works (MIT)"},\
	{"lotusnotes", 1352, "Lotus Note"},\
	{"relief", 1353, "Relief Consulting"},\
	{"rightbrain", 1354, "RightBrain Software"},\
	{"intuitive-edge", 1355, "Intuitive Edge"},\
	{"cuillamartin", 1356, "CuillaMartin Company"},\
	{"pegboard", 1357, "Electronic PegBoard"},\
	{"connlcli", 1358, ""},\
	{"ftsrv", 1359, ""},\
	{"mimer", 1360, ""},\
	{"linx", 1361, ""},\
	{"timeflies", 1362, ""},\
	{"ndm-requester", 1363, "Network DataMover Requester"},\
	{"ndm-server", 1364, "Network DataMover Server"},\
	{"adapt-sna", 1365, "Network Software Associates"},\
	{"netware-csp", 1366, "Novell NetWare Comm Service Platform"},\
	{"dcs", 1367, ""},\
	{"screencast", 1368, ""},\
	{"gv-us", 1369, "GlobalView to Unix Shell"},\
	{"us-gv", 1370, "Unix Shell to GlobalView"},\
	{"fc-cli", 1371, "Fujitsu Config Protocol"},\
	{"fc-ser", 1372, "Fujitsu Config Protocol"},\
	{"chromagrafx", 1373, ""},\
	{"molly", 1374, "EPI Software Systems"},\
	{"bytex", 1375, ""},\
	{"ibm-pps", 1376, "IBM Person to Person Software"},\
	{"cichlid", 1377, "Cichlid License Manager"},\
	{"elan", 1378, "Elan License Manager"},\
	{"dbreporter", 1379, "Integrity Solutions"},\
	{"telesis-licman", 1380, "Telesis Network License Manager"},\
	{"apple-licman", 1381, "Apple Network License Manager"},\
	{"gwha", 1383, "GW Hannaway Network License Manager"},\
	{"os-licman", 1384, "Objective Solutions License Manager"},\
	{"atex_elmd", 1385, "Atex Publishing License Manager"},\
	{"checksum", 1386, "CheckSum License Manager"},\
	{"cadsi-lm", 1387, "Computer Aided Design Software Inc LM"},\
	{"objective-dbc", 1388, "Objective Solutions DataBase Cache"},\
	{"iclpv-dm", 1389, "Document Manager"},\
	{"iclpv-sc", 1390, "Storage Controller"},\
	{"iclpv-sas", 1391, "Storage Access Server"},\
	{"iclpv-pm", 1392, "Print Manager"},\
	{"iclpv-nls", 1393, "Network Log Server"},\
	{"iclpv-nlc", 1394, "Network Log Client"},\
	{"iclpv-wsm", 1395, "PC Workstation Manager software"},\
	{"dvl-activemail", 1396, "DVL Active Mail"},\
	{"audio-activmail", 1397, "Audio Active Mail"},\
	{"video-activmail", 1398, "Video Active Mail"},\
	{"cadkey-licman", 1399, "Cadkey License Manager"},\
	{"cadkey-tablet", 1400, "Cadkey Tablet Daemon"},\
	{"goldleaf-licman", 1401, "Goldleaf License Manager"},\
	{"prm-sm-np", 1402, "Prospero Resource Manager"},\
	{"prm-nm-np", 1403, "Prospero Resource Manager"},\
	{"igi-lm", 1404, "Infinite Graphics License Manager"},\
	{"ibm-res", 1405, "IBM Remote Execution Starter"},\
	{"netlabs-lm", 1406, "NetLabs License Manager"},\
	{"dbsa-lm", 1407, "DBSA License Manager"},\
	{"sophia-lm", 1408, "Sophia License Manager"},\
	{"here-lm", 1409, "Here License Manager"},\
	{"hiq", 1410, "HiQ License Manager"},\
	{"af", 1411, "AudioFile"},\
	{"innosys", 1412, ""},\
	{"innosys-acl", 1413, ""},\
	{"ibm-mqseries", 1414, "IBM MQSeries"},\
	{"dbstar", 1415, ""},\
	{"novell-lu6.2", 1416, "Novell LU6.2"},\
	{"timbuktu-srv1", 1417, "Timbuktu Service 1 Port"},\
	{"timbuktu-srv2", 1418, "Timbuktu Service 2 Port"},\
	{"timbuktu-srv3", 1419, "Timbuktu Service 3 Port"},\
	{"timbuktu-srv4", 1420, "Timbuktu Service 4 Port"},\
	{"gandalf-lm", 1421, "Gandalf License Manager"},\
	{"autodesk-lm", 1422, "Autodesk License Manager"},\
	{"essbase", 1423, "Essbase Arbor Software"},\
	{"hybrid", 1424, "Hybrid Encryption Protocol"},\
	{"zion-lm", 1425, "Zion Software License Manager"},\
	{"sas-1", 1426, "Satellite-data Acquisition System 1"},\
	{"mloadd", 1427, "mloadd monitoring tool"},\
	{"informatik-lm", 1428, "Informatik License Manager"},\
	{"nms", 1429, "Hypercom NMS"},\
	{"tpdu", 1430, "Hypercom TPDU"},\
	{"rgtp", 1431, "Reverse Gossip Transport"},\
	{"blueberry-lm", 1432, "Blueberry Software License Manager"},\
	{"ms-sql-s", 1433, "Microsoft-SQL-Server"},\
	{"ms-sql-m", 1434, "Microsoft-SQL-Monitor"},\
	{"ibm-cics", 1435, ""},\
	{"sas-2", 1436, "Satellite-data Acquisition System 2"},\
	{"tabula", 1437, ""},\
	{"eicon-server", 1438, "Eicon Security Agent/Server"},\
	{"eicon-x25", 1439, "Eicon X25/SNA Gateway"},\
	{"eicon-slp", 1440, "Eicon Service Location Protocol"},\
	{"cadis-1", 1441, "Cadis License Management"},\
	{"cadis-2", 1442, "Cadis License Management"},\
	{"ies-lm", 1443, "Integrated Engineering Software"},\
	{"marcam-lm", 1444, "Marcam License Management"},\
	{"proxima-lm", 1445, "Proxima License Manager"},\
	{"ora-lm", 1446, "Optical Research Associates License Manager"},\
	{"apri-lm", 1447, "Applied Parallel Research LM"},\
	{"oc-lm", 1448, "OpenConnect License Manager"},\
	{"peport", 1449, ""},\
	{"dwf", 1450, "Tandem Distributed Workbench Facility"},\
	{"infoman", 1451, "IBM Information Management"},\
	{"gtegsc-lm", 1452, "GTE Government Systems License Man"},\
	{"genie-lm", 1453, "Genie License Manager"},\
	{"interhdl_elmd", 1454, "interHDL License Manager"},\
	{"esl-lm", 1455, "ESL License Manager"},\
	{"dca", 1456, ""},\
	{"valisys-lm", 1457, "Valisys License Manager"},\
	{"nrcabq-lm", 1458, "Nichols Research Corp."},\
	{"proshare1", 1459, "Proshare Notebook Application"},\
	{"proshare2", 1460, "Proshare Notebook Application"},\
	{"ibm_wrless_lan", 1461, "IBM Wireless LAN"},\
	{"world-lm", 1462, "World License Manager"},\
	{"nucleus", 1463, ""},\
	{"msl_lmd", 1464, "MSL License Manager"},\
	{"pipes", 1465, "Pipes Platform"},\
	{"csdmbase", 1467, ""},\
	{"csdm", 1468, ""},\
	{"aal-lm", 1469, "Active Analysis Limited License Manager"},\
	{"uaiact", 1470, "Universal Analytics"},\
	{"csdmbase", 1471, ""},\
	{"csdm", 1472, ""},\
	{"openmath", 1473, ""},\
	{"telefinder", 1474, ""},\
	{"taligent-lm", 1475, "Taligent License Manager"},\
	{"clvm-cfg", 1476, ""},\
	{"ms-sna-server", 1477, ""},\
	{"ms-sna-base", 1478, ""},\
	{"dberegister", 1479, ""},\
	{"pacerforum", 1480, ""},\
	{"airs", 1481, ""},\
	{"miteksys-lm", 1482, "Miteksys License Manager"},\
	{"afs", 1483, "AFS License Manager"},\
	{"confluent", 1484, "Confluent License Manager"},\
	{"lansource", 1485, ""},\
	{"nms_topo_serv", 1486, ""},\
	{"localinfosrvr", 1487, ""},\
	{"docstor", 1488, ""},\
	{"dmdocbroker", 1489, ""},\
	{"insitu-conf", 1490, ""},\
	{"anynetgateway", 1491, ""},\
	{"stone-design-1", 1492, ""},\
	{"netmap_lm", 1493, ""},\
	{"citrix-ica", 1494, ""},\
	{"cvc", 1495, ""},\
	{"liberty-lm", 1496, ""},\
	{"rfx-lm", 1497, ""},\
	{"watcom-sql", 1498, ""},\
	{"fhc", 1499, "Federico Heinz Consultora"},\
	{"vlsi-lm", 1500, "VLSI License Manager"},\
	{"sas-3", 1501, "Satellite-data Acquisition System 3"},\
	{"shivadiscovery", 1502, "Shiva"},\
	{"imtc-mcs", 1503, "Databeam"},\
	{"evb-elm", 1504, "EVB Software Engineering License Manager"},\
	{"funkproxy", 1505, "Funk Software, Inc."},\
	{"utcd", 1506, "Universal Time daemon (utcd)"},\
	{"symplex", 1507, ""},\
	{"diagmond", 1508, ""},\
	{"robcad-lm", 1509, "Robcad, Ltd. License Manager"},\
	{"mvx-lm", 1510, "Midland Valley Exploration Ltd. Lic. Man."},\
	{"3l-l1", 1511, ""},\
	{"wins", 1512, "Microsoft's Windows Internet Name Service"},\
	{"fujitsu-dtc", 1513, "Fujitsu Systems Business of America, Inc"},\
	{"fujitsu-dtcns", 1514, "Fujitsu Systems Business of America, Inc"},\
	{"ifor-protocol", 1515, ""},\
	{"vpad", 1516, "Virtual Places Audio data"},\
	{"vpac", 1517, "Virtual Places Audio control"},\
	{"vpvd", 1518, "Virtual Places Video data"},\
	{"vpvc", 1519, "Virtual Places Video control"},\
	{"atm-zip-office", 1520, "atm zip office"},\
	{"ncube-lm", 1521, "nCube License Manager"},\
	{"rna-lm", 1522, "Ricardo North America License Manager"},\
	{"cichild-lm", 1523, ""},\
	{"ingreslock", 1524, "ingres"},\
	{"orasrv", 1525, "oracle or Prospero Directory Service non-priv"},\
	{"pdap-np", 1526, "Prospero Data Access Prot non-priv"},\
	{"tlisrv", 1527, "oracle"},\
	{"mciautoreg", 1528, ""},\
	{"support", 1529, "prmsd gnatsd	# cygnus bug tracker"},\
	{"rap-service", 1530, ""},\
	{"rap-listen", 1531, ""},\
	{"miroconnect", 1532, ""},\
	{"virtual-places", 1533, "Virtual Places Software"},\
	{"micromuse-lm", 1534, ""},\
	{"ampr-info", 1535, ""},\
	{"ampr-inter", 1536, ""},\
	{"sdsc-lm", 1537, ""},\
	{"3ds-lm", 1538, ""},\
	{"intellistor-lm", 1539, "Intellistor License Manager"},\
	{"rds", 1540, ""},\
	{"rds2", 1541, ""},\
	{"gridgen-elmd", 1542, ""},\
	{"simba-cs", 1543, ""},\
	{"aspeclmd", 1544, ""},\
	{"vistium-share", 1545, ""},\
	{"abbaccuray", 1546, ""},\
	{"laplink", 1547, ""},\
	{"axon-lm", 1548, "Axon License Manager"},\
	{"shivahose", 1549, "Shiva Hose"},\
	{"3m-image-lm", 1550, "Image Storage license manager 3M Company"},\
	{"hecmtl-db", 1551, ""},\
	{"pciarray", 1552, ""},\
	{"issd", 1600, ""},\
	{"nkd", 1650, ""},\
	{"shiva_confsrvr", 1651, ""},\
	{"xnmp", 1652, ""},\
	{"netview-aix-1", 1661, ""},\
	{"netview-aix-2", 1662, ""},\
	{"netview-aix-3", 1663, ""},\
	{"netview-aix-4", 1664, ""},\
	{"netview-aix-5", 1665, ""},\
	{"netview-aix-6", 1666, ""},\
	{"netview-aix-7", 1667, ""},\
	{"netview-aix-8", 1668, ""},\
	{"netview-aix-9", 1669, ""},\
	{"netview-aix-10", 1670, ""},\
	{"netview-aix-11", 1671, ""},\
	{"netview-aix-12", 1672, ""},\
	{"pptp", 1723, "Point-to-point tunnelling protocol"},\
	{"pcm", 1827, "PCM Agent (AutoSecure Policy Compliance Manager"},\
	{"licensedaemon", 1986, "cisco license management"},\
	{"tr-rsrb-p1", 1987, "cisco RSRB Priority 1 port"},\
	{"tr-rsrb-p2", 1988, "cisco RSRB Priority 2 port"},\
	{"tr-rsrb-p3", 1989, "cisco RSRB Priority 3 port"},\
	{"stun-p1", 1990, "cisco STUN Priority 1 port"},\
	{"stun-p2", 1991, "cisco STUN Priority 2 port"},\
	{"stun-p3", 1992, "cisco STUN Priority 3 port"},\
	{"snmp-tcp-port", 1993, "cisco SNMP TCP port"},\
	{"stun-port", 1994, "cisco serial tunnel port"},\
	{"perf-port", 1995, "cisco perf port"},\
	{"tr-rsrb-port", 1996, "cisco Remote SRB port"},\
	{"gdp-port", 1997, "cisco Gateway Discovery Protocol"},\
	{"x25-svc-port", 1998, "cisco X.25 service (XOT)"},\
	{"tcp-id-port", 1999, "cisco identification port"},\
	{"callbook", 2000, ""},\
	{"dc", 2001, ""},\
	{"globe", 2002, ""},\
	{"cfingerd", 2003, "GNU finger"},\
	{"mailbox", 2004, ""},\
	{"deslogin", 2005, "encrypted symmetric telnet/login"},\
	{"invokator", 2006, ""},\
	{"dectalk", 2007, ""},\
	{"conf", 2008, ""},\
	{"news", 2009, ""},\
	{"search", 2010, ""},\
	{"raid-cc", 2011, "raid"},\
	{"ttyinfo", 2012, ""},\
	{"raid-am", 2013, ""},\
	{"troff", 2014, ""},\
	{"cypress", 2015, ""},\
	{"bootserver", 2016, ""},\
	{"cypress-stat", 2017, ""},\
	{"terminaldb", 2018, ""},\
	{"whosockami", 2019, ""},\
	{"xinupageserver", 2020, ""},\
	{"servexec", 2021, ""},\
	{"down", 2022, ""},\
	{"xinuexpansion3", 2023, ""},\
	{"xinuexpansion4", 2024, ""},\
	{"ellpack", 2025, ""},\
	{"scrabble", 2026, ""},\
	{"shadowserver", 2027, ""},\
	{"submitserver", 2028, ""},\
	{"device2", 2030, ""},\
	{"blackboard", 2032, ""},\
	{"glogger", 2033, ""},\
	{"scoremgr", 2034, ""},\
	{"imsldoc", 2035, ""},\
	{"objectmanager", 2038, ""},\
	{"lam", 2040, ""},\
	{"interbase", 2041, ""},\
	{"isis", 2042, ""},\
	{"isis-bcast", 2043, ""},\
	{"rimsl", 2044, ""},\
	{"cdfunc", 2045, ""},\
	{"sdfunc", 2046, ""},\
	{"dls", 2047, ""},\
	{"dls-monitor", 2048, ""},\
	{"nfs", 2049, "networked file system"},\
	{"dlsrpn", 2065, "Data Link Switch Read Port Number"},\
	{"dlswpn", 2067, "Data Link Switch Write Port Number"},\
	{"eklogin", 2105, "Kerberos (v4) encrypted rlogin"},\
	{"ekshell", 2106, "Kerberos (v4) encrypted rshell"},\
	{"rkinit", 2108, "Kerberos (v4) remote initialization"},\
	{"kx", 2111, "X over kerberos"},\
	{"kip", 2112, "IP over kerberos"},\
	{"kauth", 2120, "Remote kauth"},\
	{"ats", 2201, "Advanced Training System Program"},\
	{"ivs-video", 2232, "IVS Video default"},\
	{"ivsd", 2241, "IVS Daemon"},\
	{"compaqdiag", 2301, "Compaq remote diagnostic/management"},\
	{"pehelp", 2307, ""},\
	{"cvspserver", 2401, "CVS network server"},\
	{"venus", 2430, ""},\
	{"venus-se", 2431, ""},\
	{"codasrv", 2432, ""},\
	{"codasrv-se", 2433, ""},\
	{"rtsserv", 2500, "Resource Tracking system server"},\
	{"rtsclient", 2501, "Resource Tracking system client"},\
	{"hp-3000-telnet", 2564, "HP 3000 NS/VT block mode telnet"},\
	{"zebrasrv", 2600, "zebra service"},\
	{"zebra", 2601, "zebra vty"},\
	{"ripd", 2602, "RIPd vty"},\
	{"ripngd", 2603, "RIPngd vty"},\
	{"ospfd", 2604, "OSPFd vty"},\
	{"bgpd", 2605, "BGPd vty"},\
	{"webster", 2627, "Network dictionary"},\
	{"sybase", 2638, "Sybase database"},\
	{"listen", 2766, "System V listener port"},\
	{"www-dev", 2784, "world wide web - development"},\
	{"ppp", 3000, "User-level ppp daemon"},\
	{"nessusd", 3001, "Nessus Security Scanner (www.nessus.org) Daemon"},\
	{"deslogin", 3005, "encrypted symmetric telnet/login"},\
	{"deslogind", 3006, ""},\
	{"cfs", 3049, "cryptographic file system (nfs) (proposed)"},\
	{"distrib-net-proxy", 3064, "Stupid closed source distributed.net project proxy port"},\
	{"sj3", 3086, "SJ3 (kanji input)"},\
	{"squid-http", 3128, "squid-ipc         3130/udp   #"},\
	{"vmodem", 3141, ""},\
	{"ccmail", 3264, "cc:mail/lotus"},\
	{"mysql", 3306, "mySQL"},\
	{"dec-notes", 3333, "DEC Notes"},\
	{"msrdp", 3389, "Micro$oft Remote Display Protocol"},\
	{"bmap", 3421, "Bull Apprise portmapper"},\
	{"prsvp", 3455, "RSVP Port"},\
	{"vat", 3456, "VAT default data"},\
	{"vat-control", 3457, "VAT default control"},\
	{"track", 3462, "software distribution"},\
	{"udt_os", 3900, "Unidata UDT OS"},\
	{"mapper-nodemgr", 3984, "MAPPER network node manager"},\
	{"mapper-mapethd", 3985, "MAPPER TCP/IP server"},\
	{"mapper-ws_ethd", 3986, "MAPPER workstation server"},\
	{"netcheque", 4008, "NetCheque accounting"},\
	{"lockd", 4045, ""},\
	{"nuts_dem", 4132, "NUTS Daemon"},\
	{"nuts_bootp", 4133, "NUTS Bootp Server"},\
	{"wincim", 4144, "pc windows compuserve.com protocol"},\
	{"rwhois", 4321, "Remote Who Is"},\
	{"msql", 4333, "mini-sql server"},\
	{"unicall", 4343, ""},\
	{"krb524", 4444, "Kerberos 5 to 4 ticket xlator"},\
	{"sae-urn", 4500, ""},\
	{"fax", 4557, "FlexFax FAX transmission service"},\
	{"hylafax", 4559, "HylaFAX client-server protocol"},\
	{"rfa", 4672, "remote file access server"},\
	{"fics", 5000, "Free Internet Chess Server"},\
	{"commplex-link", 5001, ""},\
	{"rfe", 5002, "Radio Free Ethernet"},\
	{"telelpathstart", 5010, ""},\
	{"telelpathattack", 5011, ""},\
	{"mmcc", 5050, "multimedia conference control tool"},\
	{"rmonitor_secure", 5145, ""},\
	{"aol", 5190, "America-Online"},\
	{"aol-1", 5191, "AmericaOnline1"},\
	{"aol-2", 5192, "AmericaOnline2"},\
	{"aol-3", 5193, "AmericaOnline3"},\
	{"sgi-dgl", 5232, "SGI Distributed Graphics"},\
	{"padl2sim", 5236, ""},\
	{"hacl-hb", 5300, "HA cluster heartbeat"},\
	{"hacl-gs", 5301, "HA cluster general services"},\
	{"hacl-cfg", 5302, "HA cluster configuration"},\
	{"hacl-probe", 5303, "HA cluster probing"},\
	{"hacl-local", 5304, ""},\
	{"hacl-test", 5305, ""},\
	{"cfengine", 5308, ""},\
	{"postgres", 5432, "postgres database server"},\
	{"secureidprop", 5510, "ACE/Server services"},\
	{"sdlog", 5520, "ACE/Server services"},\
	{"sdserv", 5530, "ACE/Server services"},\
	{"sdreport", 5540, "ACE/Server services"},\
	{"sdadmind", 5550, "ACE/Server services"},\
	{"pcanywheredata", 5631, ""},\
	{"pcanywherestat", 5632, ""},\
	{"canna", 5680, "Canna (Japanese Input)"},\
	{"proshareaudio", 5713, "proshare conf audio"},\
	{"prosharevideo", 5714, "proshare conf video"},\
	{"prosharedata", 5715, "proshare conf data"},\
	{"prosharerequest", 5716, "proshare conf request"},\
	{"prosharenotify", 5717, "proshare conf notify"},\
	{"vnc", 5800, ""},\
	{"vnc", 5801, ""},\
	{"vnc", 5900, "Virtual Network Computer"},\
	{"vnc-1", 5901, "Virtual Network Computer Display :1"},\
	{"vnc-2", 5902, "Virtual Network Computer Display :2"},\
	{"ncd-pref-tcp", 5977, "NCD preferences tcp port"},\
	{"ncd-diag-tcp", 5978, "NCD diagnostic tcp port"},\
	{"ncd-conf-tcp", 5979, "NCD configuration tcp port"},\
	{"ncd-pref", 5997, "NCD preferences telnet port"},\
	{"ncd-diag", 5998, "NCD diagnostic telnet port"},\
	{"ncd-conf", 5999, "NCD configuration telnet port"},\
	{"X11", 6000, "X Window server"},\
	{"X11:1", 6001, "X Window server"},\
	{"X11:2", 6002, "X Window server"},\
	{"X11:3", 6003, "X Window server"},\
	{"X11:4", 6004, "X Window server"},\
	{"X11:5", 6005, "X Window server"},\
	{"X11:6", 6006, "X Window server"},\
	{"X11:7", 6007, "X Window server"},\
	{"X11:8", 6008, "X Window server"},\
	{"X11:9", 6009, "X Window server"},\
	{"softcm", 6110, "HP SoftBench CM"},\
	{"spc", 6111, "HP SoftBench Sub-Process Control"},\
	{"dtspc", 6112, "CDE subprocess control"},\
	{"meta-corp", 6141, "Meta Corporation License Manager"},\
	{"aspentec-lm", 6142, "Aspen Technology License Manager"},\
	{"watershed-lm", 6143, "Watershed License Manager"},\
	{"statsci1-lm", 6144, "StatSci License Manager - 1"},\
	{"statsci2-lm", 6145, "StatSci License Manager - 2"},\
	{"lonewolf-lm", 6146, "Lone Wolf Systems License Manager"},\
	{"montage-lm", 6147, "Montage License Manager"},\
	{"ricardo-lm", 6148, "Ricardo North America License Manager"},\
	{"xdsxdm", 6558, ""},\
	{"irc-serv", 6666, "internet relay chat server"},\
	{"irc", 6667, "Internet Relay Chat"},\
	{"irc", 6668, "Internet Relay Chat"},\
	{"acmsoda", 6969, ""},\
	{"afs3-fileserver", 7000, "file server itself, msdos"},\
	{"afs3-callback", 7001, "callbacks to cache managers"},\
	{"afs3-prserver", 7002, "users & groups database"},\
	{"afs3-vlserver", 7003, "volume location database"},\
	{"afs3-kaserver", 7004, "AFS/Kerberos authentication service"},\
	{"afs3-volser", 7005, "volume managment server"},\
	{"afs3-errors", 7006, "error interpretation service"},\
	{"afs3-bos", 7007, "basic overseer process"},\
	{"afs3-update", 7008, "server-to-server updater"},\
	{"afs3-rmtsys", 7009, "remote cache manager service"},\
	{"ups-onlinet", 7010, "onlinet uninterruptable power supplies"},\
	{"font-service", 7100, "X Font Service"},\
	{"fodms", 7200, "FODMS FLIP"},\
	{"dlip", 7201, ""},\
	{"icb", 7326, "Internet Citizen's Band"},\
	{"http-proxy", 8080, "Common HTTP proxy/second web server port"},\
	{"sun-answerbook", 8888, "Sun Answerbook HTTP server"},\
	{"seosload", 8892, "From the new Computer Associates eTrust ACX"},\
	{"zeus-admin", 9090, "Zeus admin server"},\
	{"jetdirect", 9100, "HP JetDirect card"},\
	{"man", 9535, ""},\
	{"sd", 9876, "Session Director"},\
	{"stel", 10005, "Secure telnet"},\
	{"amandaidx", 10082, "Amanda indexing"},\
	{"amidxtape", 10083, "Amanda tape indexing"},\
	{"pksd", 11371, "PGP Public Key Server"},\
	{"NetBus", 12345, "NetBus backdoor trojan"},\
	{"NetBus", 12346, "NetBus backdoor trojan"},\
	{"isode-dua", 17007, ""},\
	{"biimenu", 18000, "Beckman Instruments, Inc."},\
	{"btx", 20005, "xcept4 (Interacts with German Telekom's CEPT videotext service)"},\
	{"wnn6", 22273, "Wnn6 (Japanese input)"},\
	{"wnn6_Cn", 22289, "Wnn6 (Chinese input)"},\
	{"wnn6_Kr", 22305, "Wnn6 (Korean input)"},\
	{"wnn6_Tw", 22321, "Wnn6 (Taiwanse input)"},\
	{"wnn6_DS", 26208, "Wnn6 (Dserver)"},\
	{"Trinoo_Master", 27665, "Trinoo distributed attack tool Master server control port"},\
	{"Elite", 31337, "Sometimes interesting stuff can be found here"},\
	{"sometimes-rpc3", 32770, "Sometimes an RPC port on my Solaris box"},\
	{"sometimes-rpc5", 32771, "Sometimes an RPC port on my Solaris box (rusersd)"},\
	{"sometimes-rpc7", 32772, "Sometimes an RPC port on my Solaris box (status)"},\
	{"sometimes-rpc9", 32773, "Sometimes an RPC port on my Solaris box (rquotad)"},\
	{"sometimes-rpc11", 32774, "Sometimes an RPC port on my Solaris box (rusersd)"},\
	{"sometimes-rpc13", 32775, "Sometimes an RPC port on my Solaris box (status)"},\
	{"sometimes-rpc15", 32776, "Sometimes an RPC port on my Solaris box (sprayd)"},\
	{"sometimes-rpc17", 32777, "Sometimes an RPC port on my Solaris box (walld)"},\
	{"sometimes-rpc19", 32778, "Sometimes an RPC port on my Solaris box (rstatd)"},\
	{"sometimes-rpc21", 32779, "Sometimes an RPC port on my Solaris box"},\
	{"sometimes-rpc23", 32780, "Sometimes an RPC port on my Solaris box"},\
	{"sometimes-rpc25", 32786, "Sometimes an RPC port (mountd)"},\
	{"sometimes-rpc27", 32787, "Sometimes an RPC port dmispd (DMI Service Provider)"},\
	{"reachout", 43188, ""},\
	{"dbbrowse", 47557, "Databeam Corporation"},\
	{"pcanywhere", 65301, ""}
	};

	st.tab=services_tab;
	st.nb=SERVICES_NB;
	return(&st);
}

